/*
 * CyclicStringCompare.cpp
 *
 *  Created on: Oct 9, 2014
 *      Author: Radomir Polach */

#include "CyclicStringCompare.h"

namespace compare {
	
bool CyclicStringCompare::equals(const string::LinearString& u, const string::LinearString& v) {
    int n = (int)u.getContent().size();
    int i = -1, j = -1, k;
    if (n != (int) v.getContent().size()) return false;

    while(i < n - 1 && j < n - 1)
    {
        k = 1;
        while(k <= n && u.getContent()[(i + k) % n] == v.getContent()[(j + k) % n]) k++;
        if (k > n) return true;
        if (u.getContent()[(i + k) % n] > v.getContent()[(j + k) % n]) i += k; else j += k;
    }
    return false;
}

int CyclicStringCompare::compare(const string::LinearString& u, const string::LinearString& v) {
    int n = (int) u.getContent().size(), m = (int)v.getContent().size();
    int i = -1, j = -1, k;

    bool last = 0;
    while(i < n - 1 && j < m - 1)
    {
        k = 1;
        while(k <= n && u.getContent()[(i + k) % n] == v.getContent()[(j + k) % m]) k++;
        if (k > n) return 0;
        last = u.getContent()[(i + k) % n] > v.getContent()[(j + k) % m];
        if (last) i += k; else j += k;
    }
    return last ? 1 : - 1;
}

}
