/*
 * GrammarPropertiesCFG.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef GRAMMAR_PROPERTIED_CFG_H_
#define GRAMMAR_PROPERTIED_CFG_H_

#include <algorithm>
#include <deque>
#include <set>

#include <exception/AlibException.h>

#include <alphabet/Symbol.h>

namespace grammar {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class GrammarPropertiesCFG {
public:
	/**
	 * Implements steps 1 through 3 in Melichar 3.6
	 */
	template<class T>
	static std::set<alphabet::Symbol> getProductiveNonterminals( const T & grammar );

	/**
	 * Implements 
	 */
	template<class T>
	static std::set<alphabet::Symbol> getUnreachableSymbols( const T & grammar );
};

}

#endif /* GRAMMAR_PROPERTIED_CFG_H_ */
