/*
 * LanguagePropertiesCFG.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "LanguagePropertiesCFG.h"

#include <grammar/ContextFree/CFG.h>
#include <grammar/ContextFree/EpsilonFreeCFG.h>
#include <grammar/ContextFree/GNF.h>
#include <grammar/ContextFree/CNF.h>
#include <grammar/ContextFree/LG.h>
#include <grammar/Regular/LeftLG.h>
#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightLG.h>
#include <grammar/Regular/RightRG.h>

#include <std/set.hpp>

#include "../../grammar/GrammarPropertiesCFG.h"

namespace language {

template<class T>
bool LanguagePropertiesCFG::isLanguageEmpty( const T & grammar ) {
	return grammar::GrammarPropertiesCFG::getProductiveNonterminals( grammar ).count( grammar.getInitialSymbol( ) );
}

template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::CFG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::EpsilonFreeCFG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::GNF & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::CNF & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::LG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::LeftLG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::LeftRG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::RightLG & grammar );
template bool LanguagePropertiesCFG::isLanguageEmpty( const grammar::RightRG & grammar );

}

