/*
 * GlushkovSymbol.h
 *
 *  Created on: 14. 4. 2014
 *      Author: Tomas Pecka
 */

#ifndef GLUSHKOVSYMBOL_H_
#define GLUSHKOVSYMBOL_H_

#include <alphabet/Symbol.h>
#include <regexp/unbounded/UnboundedRegExpSymbol.h>


namespace regexp {

/**
 * Represents numbered symbol in glushkov algorithm.
 */
class GlushkovSymbol
{
private:
    regexp::UnboundedRegExpSymbol const * const m_regexpSymbol;
    int m_i;

public:
    GlushkovSymbol( regexp::UnboundedRegExpSymbol const * const & node, int i );
    bool operator<( GlushkovSymbol const& x ) const;
    int getId( void ) const;
    alphabet::Symbol getInputSymbol( void ) const;
    regexp::UnboundedRegExpSymbol const * getSymbolPtr( void ) const;
};

} /* namespace conversions */

#endif /* GLUSHKOVSYMBOL_H_ */
