/*
 * TrimFSM.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TRIM_FSM_H_
#define TRIM_FSM_H_

#include <algorithm>
#include <deque>
#include <set>

namespace trim {

class TrimFSM {
public:
	/**
	 * Removes dead states from FSM. Melichar 2.32
	 */
	template<class T>
	static T removeUselessStates( const T & fsm );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T removeUnreachableStates( const T & fsm );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T trim( const T & fsm );
};

}

#endif /* TRIM_FSM_H_ */
