#include <list>
#include "minimizeTest.h"

#include "minimize/dfa/MinimizeDFA.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_REGISTRATION( minimizeTest );

void minimizeTest::setUp() {
}

void minimizeTest::tearDown() {
}

void minimizeTest::testMinimize() {
  automaton::DFA automaton(automaton::State(1));

  automaton.addState(automaton::State(1));
  automaton.addState(automaton::State(2));
  automaton.addState(automaton::State(3));
  automaton.addInputSymbol(alphabet::symbolFrom("a"));
  automaton.addInputSymbol(alphabet::symbolFrom("b"));
  
  automaton.addTransition(automaton::State(1), alphabet::symbolFrom("a"), automaton::State(2));
  automaton.addTransition(automaton::State(2), alphabet::symbolFrom("b"), automaton::State(1));

  automaton.addFinalState(automaton::State(3));
  
  automaton::DFA minimized = minimize::MinimizeDFA::minimize(automaton);

  CPPUNIT_ASSERT(minimized.getStates().size() == 3);

}
