/*
 * FromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef FROM_STRING_PARSER_H_
#define FROM_STRING_PARSER_H_

#include <set>
#include "exception/AlibException.h"

namespace alib {

template<class T, class F>
class FromStringParser {
	virtual T parse() = 0;
	virtual T parse(const std::set<F>& features) = 0;
	virtual bool last() = 0;
public:
	virtual bool first() = 0;
	T* parsePointer() {
		if(first()) {
			return new T(parse());
		} else {
			return NULL;
		}
	}

	T parseValue() {
		first();
		T res = parse();

		if(last()) {
			return std::move(res);
		} else {
			throw exception::AlibException();
		}
	}
};

} /* namespace alib */

#endif /* FROM_STRING_PARSER_H_ */
