/*
 * Alphabet.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "Alphabet.h"

namespace alphabet {

const std::set<alphabet::Symbol>& Alphabet::getContent() const {
	return this->m_Data;
}

void Alphabet::insertSymbol(alphabet::Symbol&& symbol) {
	this->m_Data.insert(std::move(symbol));
}

void Alphabet::insertSymbol(const alphabet::Symbol& symbol) {
	this->m_Data.insert(symbol);
}

bool Alphabet::isEmpty() const {
	return this->m_Data.size() == 0;
}

bool Alphabet::operator==(const Alphabet& other) const {
	return this->m_Data == other.m_Data;
}
	
bool Alphabet::operator<(const Alphabet& other) const {
	return this->m_Data < other.m_Data;
}

std::ostream& operator <<(std::ostream& out, const Alphabet& alphabet) {
	out << "(Alphabet ";
	for(const alphabet::Symbol& symbol : alphabet.m_Data) {
		out << symbol;
	}
	out << ")";
	return out;
}

} /* namespace alphabet */
