/*
 * SymbolToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "SymbolToXMLComposer.h"

#include "../Api.hpp"

namespace alphabet {

std::list<sax::Token> SymbolToXMLComposer::compose(const Symbol& symbol) const {
	std::list<sax::Token> out;
	symbol.getData().Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

std::list<sax::Token> SymbolToXMLComposer::compose(const SymbolBase& symbol) const {
	std::list<sax::Token> out;
	symbol.Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

std::list<sax::Token> SymbolToXMLComposer::compose(const LabeledSymbol& symbol) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("LabeledSymbol", sax::Token::TokenType::START_ELEMENT));
	out.splice(out.end(), alib::api<label::Label>::compose(symbol.getLabel()));
	out.push_back(sax::Token("LabeledSymbol", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> SymbolToXMLComposer::compose(const BlankSymbol&) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("BlankSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("BlankSymbol", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> SymbolToXMLComposer::compose(const BottomOfTheStackSymbol&) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("BottomOfTheStackSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("BottomOfTheStackSymbol", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> SymbolToXMLComposer::compose(const EndSymbol&) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("EndSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("EndSymbol", sax::Token::TokenType::END_ELEMENT));
	return out;
}

} /* namespace alphabet */
