/*
 * Automaton.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Martin Zak
 */

#include "Automaton.h"
#include "../label/NextLabel.h"
#include "../label/Label.h"
#include <climits>
#include "AutomatonException.h"

namespace automaton {

State createUniqueState(const State& base, const std::set<State>& other) {
	label::NextLabel nextLabelCreator;

	label::Label nextLabel = base.getName();

	int i = 0;
	do {
		nextLabel = nextLabelCreator.nextLabel(nextLabel);
		if(other.count(State(nextLabel)) == 0)
			return State(nextLabel);
	} while(++i < INT_MAX);

	throw AutomatonException("Could not create unique state with base name " + (std::string) base.getName() + "." );
}

} /* namespace automaton */

