/*
 * SingleInitialStateAutomaton.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef SINGLE_INITIAL_STATE_H_
#define SINGLE_INITIAL_STATE_H_

#include "States.h"
#include "State.h"

namespace automaton {

/**
 * Base class for deterministic automata. Contains common elements of automata.
 */
class SingleInitialState : public States {
protected:
	State initialState;
public:
	SingleInitialState(const State& initialState);

	/**
	 * Set the initial state.
	 * @param state State to set
	 * @throws AutomatonException when state is not present
	 * in the automaton
	 */
	void setInitialState(const State& state);

	/**
	 * @return initial state
	 */
	const State& getInitialState() const;
};

} /* namespace automaton */

#endif /* SINGLE_INITIAL_STATE_H_ */

