/*
 * Pair.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#include "ObjectsPair.h"
#include "../std/map.hpp"

#include <cstdlib>
#include <iostream>
#include <sstream>

namespace container {

ObjectsPair::ObjectsPair(const alib::Object& first, const alib::Object& second) : std::pair<alib::Object, alib::Object>(first, second) {

}

ContainerBase* ObjectsPair::clone() const {
	return new ObjectsPair(*this);
}

ContainerBase* ObjectsPair::plunder() && {
	return new ObjectsPair(std::move(*this));
}

bool ObjectsPair::operator==(const ObjectBase& other) const {
	return other == *this;
}

bool ObjectsPair::operator<(const ObjectBase& other) const {
	return other > *this;
}

bool ObjectsPair::operator>(const ObjectBase& other) const {
	return other < *this;
}

bool ObjectsPair::operator==(const ObjectsPair& other) const {
	return static_cast<const std::pair<alib::Object, alib::Object>>(*this) == static_cast<const std::pair<alib::Object, alib::Object>>(other);
}

bool ObjectsPair::operator<(const ObjectsPair& other) const {
	return static_cast<const std::pair<alib::Object, alib::Object>>(*this) < static_cast<const std::pair<alib::Object, alib::Object>>(other);
}

void ObjectsPair::operator>>(std::ostream& os) const {
	os << *this;
}

ObjectsPair::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return std::move(ss).str();
}

} /* namespace container */
