#ifndef AUTOMATON_PRINTER_H_
#define AUTOMATON_PRINTER_H_

#include "../automaton/Automaton.h"

namespace automaton {

class AutomatonRevertor : public VisitableAutomatonBase::const_visitor_type {
	void Visit(void*, const UnknownAutomaton& automaton) const;
	void Visit(void*, const EpsilonNFA& automaton) const;
	void Visit(void*, const NFA& automaton) const;
	void Visit(void*, const DFA& automaton) const;
	void Visit(void*, const ExtendedNFA& automaton) const;
	void Visit(void*, const CompactNFA& automaton) const;
	void Visit(void*, const NPDA& automaton) const;
	void Visit(void*, const SinglePopNPDA& automaton) const;
	void Visit(void*, const OneTapeDTM& automaton) const;

public:
	UnknownAutomaton revert(const Automaton& automaton) const;

	UnknownAutomaton revert(const UnknownAutomaton& automaton) const;
	UnknownAutomaton revert(const DFA& automaton) const;
	UnknownAutomaton revert(const NFA& automaton) const;
	UnknownAutomaton revert(const EpsilonNFA& automaton) const;
	UnknownAutomaton revert(const ExtendedNFA& automaton) const;
	UnknownAutomaton revert(const CompactNFA& automaton) const;
	UnknownAutomaton revert(const NPDA& automaton) const;
	UnknownAutomaton revert(const SinglePopNPDA& automaton) const;
	UnknownAutomaton revert(const OneTapeDTM& automaton) const;
};

} /* namespace automaton */

#endif /* AUTOMATON_PRINTER_H_ */
