/*
 * GrammarFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FROM_STRING_LEXER_H_
#define GRAMMAR_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace grammar {

class GrammarFromStringLexer {
public:
	enum class TokenType {
		SET_BEGIN,
		SET_END,
		COMMA,
		TUPLE_BEGIN,
		TUPLE_END,
		SEPARATOR,
		EPSILON,
		MAPS_TO,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
	};
private:
	std::istream& m_In;
	Token m_Current;
public:

	GrammarFromStringLexer(std::istream&);
	GrammarFromStringLexer& next();
	Token token();
};

} /* namepsace grammar */

#endif /* GRAMMAR_FROM_STRING_LEXER_H_ */
