/*
 * LabelFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_STRING_PARSER_H_
#define LABEL_FROM_STRING_PARSER_H_

#include "Label.h"
#include "LabelFeatures.h"
#include <vector>
#include <set>
#include "../FromStringParser.hpp"
#include "../primitive/PrimitiveFromStringParser.h"

#include "LabelFromStringLexer.h"

namespace alphabet {

class SymbolFromStringParser;

} /* namespace alphabet */

namespace regexp {

class RegExpFromStringParser;

} /* namespace regexp */

namespace string {

class StringFromStringParser;

} /* namespace string */

namespace automaton {

class FiniteAutomatonFromStringParser;

} /* namespace automaton */

namespace label {

class LabelFromStringParser : public alib::FromStringParser<Label, FEATURES> {
	LabelFromStringLexer m_Lexer;
	primitive::PrimitiveFromStringParser m_PrimitiveParser;

	virtual Label parse(const std::set<FEATURES>&);
	virtual Label parse();

	bool next();
	virtual bool last();
public:
	virtual bool first();
	LabelFromStringParser(std::istream&);
	friend class alphabet::SymbolFromStringParser;
	friend class regexp::RegExpFromStringParser;
	friend class string::StringFromStringParser;
	friend class automaton::FiniteAutomatonFromStringParser;
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_PARSER_H_ */
