/*
 * LabelToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef LABEL_TO_XML_COMPOSER_H_
#define LABEL_TO_XML_COMPOSER_H_

#include <list>
#include "Label.h"
#include "../sax/Token.h"

namespace alib {

template<typename T>
struct api;

} /* namespace alib */

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class LabelToXMLComposer {
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const LabelBase& label) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const Label& label) const;

	std::list<sax::Token> compose(const PrimitiveLabel& label) const;
	std::list<sax::Token> compose(const HexavigesimalLabel& label) const;
	std::list<sax::Token> compose(const ObjectLabel& label) const;
	std::list<sax::Token> compose(const LabelSetLabel& label) const;
	std::list<sax::Token> compose(const LabelPairLabel& label) const;

	template<typename T> friend class alib::api;
};

} /* namespace label */

#endif /* LABEL_TO_XML_COMPOSER_H_ */
