/*
 * ObjectToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "ObjectToXMLComposer.h"

#include "../Api.hpp"

namespace alib {

std::list<sax::Token> ObjectToXMLComposer::compose(const Object& object) const {
	std::list<sax::Token> out;
	object.getData().Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

std::list<sax::Token> ObjectToXMLComposer::compose(const Void&) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("Void", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("Void", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> ObjectToXMLComposer::compose(const ObjectBase& object) const {
	std::list<sax::Token> out;
	object.Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

} /* namespace alib */
