/*
 * PrimitiveToStringComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrimitiveToStringComposer.h"
#include <algorithm>
#include "Integer.h"
#include "String.h"
#include "Character.h"

namespace primitive {

void PrimitiveToStringComposer::Visit(void* userData, const primitive::String& primitive) {
	std::stringstream &out = *((std::stringstream*) userData);

	auto replace = [](std::string& str, const std::string& what, const std::string& with) {
		size_t index = 0;
		while((index = str.find(what, index)) != std::string::npos) {
			str.replace(index, what.length(), with);
			index += with.length();
		}
	};
	
	std::string tmp = primitive.getData();
	replace(tmp, "'", "\\'" );
	out << '\'' << tmp << '\'';
}

void PrimitiveToStringComposer::Visit(void* userData, const Character& primitive) {
	std::stringstream &out = *((std::stringstream*) userData);

	out << primitive.getData();
}

void PrimitiveToStringComposer::Visit(void* userData, const Integer& primitive) {
	std::stringstream &out = *((std::stringstream*) userData);

	out << primitive.getData();
}

std::string PrimitiveToStringComposer::compose(const Primitive& primitive) {
	std::stringstream out;
	primitive.getData().Accept((void*) &out, *this);
	return std::move(out).str();
}

} /* namespace primitive */
