/*
 * PrimitiveToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef PRIMITIVE_TO_XML_COMPOSER_H_
#define PRIMITIVE_TO_XML_COMPOSER_H_

#include <list>
#include "Primitive.h"
#include "../sax/Token.h"

namespace alib {

template<typename T>
struct api;

} /* namespace alib */

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class PrimitiveToXMLComposer {

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const PrimitiveBase& primitive) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const Primitive& primitive) const;

	std::list<sax::Token> compose(const String& primitive) const;
	std::list<sax::Token> compose(const Integer& primitive) const;
	std::list<sax::Token> compose(const Character& primitive) const;

	template<typename T> friend class alib::api;
};

} /* namespace primitive */

#endif /* PRIMITIVE_TO_XML_COMPOSER_H_ */
