/*
 * FormalRegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "FormalRegExpElement.h"
#include <typeinfo>

#include "FormalRegExpElements.h"

namespace regexp {

FormalRegExpElement::FormalRegExpElement() : parentRegExp(NULL) {

}

FormalRegExpElement::~FormalRegExpElement() noexcept {

}

bool FormalRegExpElement::operator>=(const FormalRegExpElement& other) const {
	return !(*this < other);
}

bool FormalRegExpElement::operator<=(const FormalRegExpElement& other) const {
	return !(*this > other);
}

bool FormalRegExpElement::operator!=(const FormalRegExpElement& other) const {
	return !(*this == other);
}


bool FormalRegExpElement::operator<(const FormalRegExpConcatenation& other) const {
	return typeid(*this).before(typeid(other));
}

bool FormalRegExpElement::operator<(const FormalRegExpAlternation& other) const {
	return typeid(*this).before(typeid(other));
}

bool FormalRegExpElement::operator<(const FormalRegExpIteration& other) const {
	return typeid(*this).before(typeid(other));
}

bool FormalRegExpElement::operator<(const FormalRegExpSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool FormalRegExpElement::operator<(const FormalRegExpEpsilon& other) const {
	return typeid(*this).before(typeid(other));
}

bool FormalRegExpElement::operator<(const FormalRegExpEmpty& other) const {
	return typeid(*this).before(typeid(other));
}


bool FormalRegExpElement::operator==(const FormalRegExpConcatenation&) const {
	return false;
}

bool FormalRegExpElement::operator==(const FormalRegExpAlternation&) const {
	return false;
}

bool FormalRegExpElement::operator==(const FormalRegExpIteration&) const {
	return false;
}

bool FormalRegExpElement::operator==(const FormalRegExpSymbol&) const {
	return false;
}

bool FormalRegExpElement::operator==(const FormalRegExpEpsilon&) const {
	return false;
}

bool FormalRegExpElement::operator==(const FormalRegExpEmpty&) const {
	return false;
}

std::ostream& operator<<(std::ostream& out, const FormalRegExpElement& regexp) {
	regexp >> out;
	return out;
}

} /* namespace regexp */
