/*
 * UnboundedRegExpEmpty.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "UnboundedRegExpEmpty.h"
#include "../formal/FormalRegExpEmpty.h"

namespace regexp {

UnboundedRegExpEmpty::UnboundedRegExpEmpty() {
  // so that default constructor is available
}

UnboundedRegExpEmpty::UnboundedRegExpEmpty(const UnboundedRegExpEmpty&) {
  // so that copy constructor is available
}

UnboundedRegExpEmpty::UnboundedRegExpEmpty(UnboundedRegExpEmpty&&) noexcept {
  this->attachRegExp(NULL);
}

UnboundedRegExpEmpty& UnboundedRegExpEmpty::operator =(const UnboundedRegExpEmpty&) {
  //this is actually different than default implementation
  return *this;
}

UnboundedRegExpEmpty& UnboundedRegExpEmpty::operator =(UnboundedRegExpEmpty&&) noexcept {
  //this is actually different than default implementation
  return *this;
}

UnboundedRegExpElement* UnboundedRegExpEmpty::clone() const {
	return new UnboundedRegExpEmpty(*this);
}

UnboundedRegExpElement* UnboundedRegExpEmpty::plunder() && {
	return new UnboundedRegExpEmpty(std::move(*this));
}

FormalRegExpElement* UnboundedRegExpEmpty::cloneAsFormal() const {
	return new FormalRegExpEmpty();
}

bool UnboundedRegExpEmpty::operator<(const UnboundedRegExpElement& other) const {
	return other > *this;
}

bool UnboundedRegExpEmpty::operator==(const UnboundedRegExpElement& other) const {
	return other == *this;
}

bool UnboundedRegExpEmpty::operator>(const UnboundedRegExpElement& other) const {
	return other < *this;
}


bool UnboundedRegExpEmpty::operator<(const UnboundedRegExpEmpty&) const {
	return false;
}

bool UnboundedRegExpEmpty::operator==(const UnboundedRegExpEmpty&) const {
	return true;
}

void UnboundedRegExpEmpty::operator>>(std::ostream& out) const {
	out << "(UnboundedRegExpEmpty)";
}

bool UnboundedRegExpEmpty::testSymbol( const alphabet::Symbol & ) const {
	return false;
}

bool UnboundedRegExpEmpty::attachRegExp(const UnboundedRegExp * regexp ) {
	if(this->parentRegExp == regexp) return true;
	this->parentRegExp = regexp;
	return true;
}

void UnboundedRegExpEmpty::computeMinimalAlphabet( std::set<alphabet::Symbol>&) const {

}

} /* namespace regexp */
