/*
 * Hexavigesimal.h
 *
 *  Created on: 19. 4. 2014
 *      Author: Tomas Pecka
 */

#ifndef HEXAVIGESIMAL_H_
#define HEXAVIGESIMAL_H_

#include <string>

namespace std {

/**
 * Maps 0 -> A, 1 -> B, ..., 25 -> Z, 26 -> AB, 27 -> AC, ..., 675 -> ZZ, 676 -> BAA, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
string toBase26( unsigned n );

/**
 * Maps A -> 0, B -> 0, ..., Z -> 25, AB -> 26, AC -> 27, ..., ZZ -> 675, BAA -> 676, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
unsigned fromBase26( string rep );

/**
 * Maps 1 -> A, 2 -> B, ..., 26 -> Z, 27 -> AA, 28 -> AB, ..., 675 -> ZZ, 676 -> BAA, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
string bijectiveToBase26( unsigned n );

/**
 * Maps 1 -> A, 2 -> B, ..., 26 -> Z, 27 -> AA, AB -> 28, ..., ZZ -> 675, BAA -> 676, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
unsigned bijectiveFromBase26( string rep );

} /* namespace std */

#endif /* HEXAVIGESIMAL_H_ */
