/*
 * StringAlphabetGetter.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "StringAlphabetGetter.h"

namespace string {

void StringAlphabetGetter::Visit(void* userData, const CyclicString& string) const {
	const std::set<alphabet::Symbol>* &res = *((const std::set<alphabet::Symbol>**) userData);
	res = &string.getAlphabet();
}

void StringAlphabetGetter::Visit(void* userData, const Epsilon& string) const {
	const std::set<alphabet::Symbol>* &res = *((const std::set<alphabet::Symbol>**) userData);
	res = &string.getAlphabet();
}

void StringAlphabetGetter::Visit(void* userData, const LinearString& string) const {
	const std::set<alphabet::Symbol>* &res = *((const std::set<alphabet::Symbol>**) userData);
	res = &string.getAlphabet();
}

const std::set<alphabet::Symbol>& StringAlphabetGetter::getAlphabet(const String& string) const {
	const std::set<alphabet::Symbol>* res;
	string.getData().Accept((void*) &res, *this);
	return *res;
}

const StringAlphabetGetter StringAlphabetGetter::STRING_ALPHABET_GETTER;

} /* namespace string */
